<?

mapCut("mappattern.png", "test/", 256, 83);

//=============================================================
//
// mappattern.png	- name of the map file
// test/   	- output dir
// 256		- square size
// 83		- quality
//
//=============================================================



function mapCut($filename, $destination, $ctverec, $quality)
{
   $starttime = microtime();
   $startarray = explode(" ", $starttime);
   $starttime = $startarray[1] + $startarray[0];

   set_time_limit(0);
   setMemoryForImage($filename);

   $fileend = substr($filename, -3);
   if($fileend=="jpg") { $source = imagecreatefromjpeg($filename); }
   if($fileend=="png") { $source = imagecreatefrompng($filename); }
   if(($fileend!="jpg") and ($fileend!="png")) {
     echo "Soubor musí mít koncovku .jpg nebo .png";
     exit(0);
   }
   $temp_source = $source;
   list($width, $height) = getimagesize($filename);

   $val = 1;
   $saveto = "size4";
   $m = 0;
   $trans = array("/" => "\\");
   $addr = strtr($destination, $trans);

while($m<4) {

   echo "<br>/// ".$val." :<br>";
//   if(is_file($addr.$val)) {
//	mkdir($addr.$val, 700);
//   }


   $pocet_sirka = ($width*$val)/$ctverec;
   $pocet_vyska = ($height*$val)/$ctverec;
   if(eregi(".",$pocet_sirka)) {
	$pocet_sirka = intval($pocet_sirka) + 1;
   }
   if(eregi(".",$pocet_vyska)) {
	$pocet_vyska = intval($pocet_vyska) + 1;
   }

   for($i=0;$i<$pocet_sirka;$i++) {
	$pozice_x = $i * $ctverec;
     for($j=0;$j<$pocet_vyska;$j++) {
          $pozice_y = $j * $ctverec;

	  $name = "x".$i."y".$j.".jpg";
          $velikost_x = $ctverec;
          $velikost_y = $ctverec;

	  if(($pozice_x + $ctverec) > intval($width*$val)) { $velikost_x = intval($width*$val) - $pozice_x; }
	  if(($pozice_y + $ctverec) > intval($height*$val)) { $velikost_y = intval($height*$val) - $pozice_y; }

	  if(($pozice_x!=intval($width*$val)) and ($pozice_y!=intval($height*$val))) {
	  

             $thumb  = imagecreatetruecolor($velikost_x, $velikost_y);
             imagecopy($thumb, $temp_source, 0, 0, $pozice_x, $pozice_y, intval($width*$val), intval($height*$val));

             imagejpeg($thumb,$destination.$saveto."/".$name,$quality);
             imageDestroy($thumb);

	   echo "Vytvoren obrazek: ".$name."<br>";
	   //echo "<br>Vytvoren obrazek: ".$name." ---";

	  }

//echo "   vel: ".$velikost_x." ".$velikost_y." # poz: ".$pozice_x." ".$pozice_y." # val*wh: ".intval($width*$val)." ".intval($height*$val)." ";

     }	
   }

    if($m==0) { $val = 0.70; $saveto = "size3"; }
    if($m==1) { $val = 0.50; $saveto = "size2"; }
    if($m==2) { $val = 0.20; $saveto = "size1"; }

    $temp_source  = imagecreatetruecolor(intval($width*$val), intval($height*$val));
    imagecopyresampled($temp_source, $source, 0, 0, 0, 0, intval($width*$val), intval($height*$val), $width, $height);
    $m++;
}

$mini_width = 150;
$mini_height = intval($height / ($width / $mini_width));

$temp_source  = imagecreatetruecolor($mini_width, $mini_height);
imagecopyresampled($temp_source, $source, 0, 0, 0, 0, $mini_width, $mini_height, $width, $height);
imagejpeg($temp_source,$destination."mini/mini_map.jpg",$quality);

imageDestroy($source);
imageDestroy($temp_source);

$endtime = microtime();
$endarray = explode(" ", $endtime);
$endtime = $endarray[1] + $endarray[0];
$totaltime = $endtime - $starttime;
$totaltime = round($totaltime,5);
echo "<br>Prace uspesne dokoncena za <b>".$totaltime."</b> sekund = ".($totaltime/60)." minut.";

}





function setMemoryForImage($filename)
{
   $imageInfo    = getimagesize($filename);
   $memoryNeeded = round(($imageInfo[0] * $imageInfo[1] * $imageInfo['bits'] * $imageInfo['channels'] / 8 + Pow(2, 16)) * 1.65);
  
   $memoryLimit = (int) ini_get('memory_limit')*1048576;

   echo " ### Volna pamet: ".$memoryLimit."<br>";
   echo " ### Potrebna pamet: ".$memoryNeeded."<br><br>";

  if ((getMemUsage() + $memoryNeeded) > $memoryLimit)
   {
     ini_set('memory_limit', ceil((getMemUsage() + $memoryNeeded + $memoryLimit)/1048576).'M');
     return (true);
   }
   else return(false);
}

function getMemUsage()
{
       
        if (function_exists('memory_get_usage'))
        {
            return memory_get_usage();
        }
        else if ( strpos( strtolower($_SERVER["OS"]), 'windows') !== false)
        {
            // Windows workaround
            $output = array();
           
            exec('tasklist /FI "PID eq ' . getmypid() . '" /FO LIST', $output);           
            return substr($output[5], strpos($output[5], ':') + 1);
        }
        else
        {
            return '0';
        }
}

?>